//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * 回転補間ヘッダ
 * @author Junpee
 */

#ifndef ROTATION_INTERPOLATOR_H_
#define ROTATION_INTERPOLATOR_H_

namespace Lamp{

class RotationConstantInterpolator;
class EulerArrayInterpolator;
class QuaternionArrayInterpolator;
class QuaternionLinearInterpolator;

//------------------------------------------------------------------------------
/**
 * 回転補間
 *
 * サブクラスでコピーコンストラクタと代入演算子を実装する
 */
class RotationInterpolator{
public:
	//--------------------------------------------------------------------------
	/**
	 * デストラクタ
	 */
	virtual ~RotationInterpolator(){}

	//--------------------------------------------------------------------------
	/**
	 * 複製
	 * @return 複製された回転補間。呼び出し元でdeleteする必要がある
	 */
	virtual RotationInterpolator* duplicate() const = 0;

	/**
	 * 同じ値かどうか
	 * @param target 比較対象
	 * @return 同じ値ならtrueをかえす
	 */
	virtual bool equals(const RotationInterpolator& target) const = 0;

	//--------------------------------------------------------------------------
	/**
	 * 長さの取得
	 * @return 長さ
	 */
	virtual float getLength() const = 0;

	//--------------------------------------------------------------------------
	// オイラー補間
	//--------------------------------------------------------------------------
	/**
	 * オイラー補間かどうか
	 * @return オイラー補間ならtrue
	 */
	virtual bool isEulerInterpolator() const = 0;

	/**
	 * オイラー補間
	 * @param time 時間
	 * @return 補間された回転
	 */
	virtual Vector3 eulerInterpolate(float time) = 0;

	//--------------------------------------------------------------------------
	// クォータニオン補間
	//--------------------------------------------------------------------------
	/**
	 * クォータニオン補間かどうか
	 * @return クォータニオン補間ならtrue
	 */
	virtual bool isQuaternionInterpolator() const = 0;

	/**
	 * クォータニオン補間
	 * @param time 時間
	 * @return 補間された回転
	 */
	virtual Quaternion quaternionInterpolate(float time) = 0;

	//--------------------------------------------------------------------------
	// RTTI
	//--------------------------------------------------------------------------
	/**
	 * 回転定数補間かどうか
	 * @return 回転定数補間ならtrue
	 */
	virtual bool isRotationConstantInterpolator() const{ return false; }

	/**
	 * 回転定数補間へのキャスト
	 * @return 回転定数補間。型が違えばNULLを返す。
	 */
	virtual RotationConstantInterpolator*
		castRotationConstantInterpolator() const{
		if(isRotationConstantInterpolator()){
			return (RotationConstantInterpolator*)this;
		}
		return NULL;
	}

	//--------------------------------------------------------------------------
	/**
	 * オイラー回転配列補間かどうか
	 * @return オイラー回転配列補間ならtrue
	 */
	virtual bool isEulerArrayInterpolator() const{ return false; }

	/**
	 * オイラー回転配列補間へのキャスト
	 * @return オイラー回転配列補間。型が違えばNULLを返す。
	 */
	virtual EulerArrayInterpolator*
		castEulerArrayInterpolator() const{
		if(isEulerArrayInterpolator()){
			return (EulerArrayInterpolator*)this;
		}
		return NULL;
	}

	//--------------------------------------------------------------------------
	/**
	 * 四元数回転配列補間かどうか
	 * @return 四元数回転配列補間ならtrue
	 */
	virtual bool isQuaternionArrayInterpolator() const{ return false; }

	/**
	 * 四元数回転配列補間へのキャスト
	 * @return 四元数回転配列補間。型が違えばNULLを返す。
	 */
	virtual QuaternionArrayInterpolator*
		castQuaternionArrayInterpolator() const{
		if(isQuaternionArrayInterpolator()){
			return (QuaternionArrayInterpolator*)this;
		}
		return NULL;
	}

	//--------------------------------------------------------------------------
	/**
	 * 四元数回転線形補間かどうか
	 * @return 四元数回転線形補間ならtrue
	 */
	virtual bool isQuaternionLinearInterpolator() const{ return false; }

	/**
	 * 四元数回転線形補間へのキャスト
	 * @return 四元数回転線形補間。型が違えばNULLを返す。
	 */
	virtual QuaternionLinearInterpolator*
		castQuaternionLinearInterpolator() const{
		if(isQuaternionLinearInterpolator()){
			return (QuaternionLinearInterpolator*)this;
		}
		return NULL;
	}

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of ROTATION_INTERPOLATOR_H_
//------------------------------------------------------------------------------

